// From: https://en.cppreference.com/w/cpp/utility/source_location

#include <iostream>
#include <source_location>
#include <string_view>

void log(const std::string_view message,
         const std::source_location location = std::source_location::current())
{
    std::cout << location.file_name() << "(" << location.line() << ") `"
              << location.function_name() << "`: " << message << '\n';
}

void grandParentFunction()
{
    log("grandParent");
}
void parentFunction()
{
    log("parent");
    grandParentFunction();
}
void childFunction()
{
    log("child");
    parentFunction();
}

int main()
{
    log("main");
    childFunction();
    return 0;
}
